/*
// $Id: //guest/julian_hyde/saffron/src/main/saffron/opt/Cluster.java#3 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
// 
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
*/

package saffron.opt;
import openjava.mop.Environment;
import openjava.ptree.Expression;

/**
 * A <code>Cluster</code> is a collection of {@link saffron.rel.Rel}ational expressions
 * which have the same environment.
 *
 * <p>See the comment against {@link saffron.rel.QueryInfo} on why you should
 * put fields in that class, not this one.</p>
 *
 * @author jhyde
 * @since 27 September, 2001
 * @version $Id: //guest/julian_hyde/saffron/src/main/saffron/opt/Cluster.java#3 $
 **/
public class Cluster {
	public Query query;
	public Environment env;
	private Expression originalExpression;
	public VolcanoPlanner planner;

	public Cluster(
			Query query, Environment env, VolcanoPlanner planner,
			Expression originalExpression)
	{
		this.query = query;
		this.env = env;
		this.originalExpression = originalExpression;
		this.planner = planner;
		if (this.planner == null) {
			this.planner = new VolcanoPlanner(this);
		}
	}
	public Expression getOriginalExpression() {
		return originalExpression;
	}
}

// End Cluster.java
