/*
// $Id: //guest/julian_hyde/saffron/src/main/saffron/rel/convert/NoneConverter.java#2 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
// 
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
*/

package saffron.rel.convert;

import saffron.opt.CallingConvention;
import saffron.opt.Cluster;
import saffron.rel.Rel;

/**
 * <code>NoneConverter</code> converts a plan from <code>inConvention</code> to
 * {@link saffron.opt.CallingConvention#NONE}.
 *
 * @author jhyde
 * @since 15 February, 2002
 * @version $Id: //guest/julian_hyde/saffron/src/main/saffron/rel/convert/NoneConverter.java#2 $
 **/
class NoneConverter extends Converter
{
	NoneConverter(Cluster cluster, Rel child, int inConvention)
	{
		super(cluster, child, inConvention);
	}

	public Object clone()
	{
		return new NoneConverter(this.cluster, child, inConvention);
	}

	// implement Rel
	public int getConvention()
	{
		return CallingConvention.NONE;
	}

	public static boolean canConvert(int inConvention)
	{
		return true;
	}
}



// End NoneConverter.java
