/*
// $Id: //guest/julian_hyde/saffron/src/main/saffron/rel/java/JavaTableAccess.java#1 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
// 
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
*/

package saffron.rel.java;

import openjava.ptree.Expression;
import saffron.ImplementableTable;
import saffron.opt.CallingConvention;
import saffron.opt.Cluster;
import saffron.opt.Implementor;
import saffron.rel.TableAccess;
import saffron.util.Util;

public class JavaTableAccess extends TableAccess
{
    public JavaTableAccess(
        Cluster cluster, ImplementableTable table,
        Expression connectionExp)
    {
        super(cluster, table, connectionExp);
    }
    public Object clone()
    {
        return this;
    }
    public int getConvention()
    {
        return CallingConvention.JAVA;
    }
    // implement Rel
    public Object implement(Implementor implementor, int ordinal)
    {
        switch (ordinal) {
        case -1: // called from parent
            ImplementableTable implementableTable = (ImplementableTable)
                table;
            implementableTable.implement(this, implementor);
            return null;

        default:
            throw Util.newInternal(
                "implement: ordinal=" + ordinal);
        }
    }
}
