/*
// $Id: //guest/julian_hyde/saffron/src/main/saffron/rel/plan/PlanArrayReader.java#2 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
// 
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
*/

package saffron.rel.plan;

import openjava.ptree.Expression;
import saffron.opt.CallingConvention;
import saffron.opt.Cluster;
import saffron.opt.Implementor;
import saffron.rel.ExpressionReader;
import saffron.util.Util;

/**
 * <code>PlanArrayReader</code> implements {@link ExpressionReader} as a {@link
 * saffron.runtime.Plan} object.
 **/
class PlanArrayReader extends ExpressionReader
{
    PlanArrayReader(Cluster cluster, Expression exp)
    {
        super(cluster, exp, null);
    }

    public Object clone()
    {
        return new PlanArrayReader(cluster, Util.clone(exp));
    }

    // implement Rel
    public int getConvention()
    {
        return CallingConvention.PLAN;
    }

    // implement Rel
    public Object implement(Implementor implementor, int ordinal)
    {
        switch (ordinal) {
        case -1:
            return new ArrayReaderPlan(this);
        default:
            throw Util.newInternal(
                "implement: ordinal=" + ordinal);
        }
    }
}
