/*
// $Id: //guest/julian_hyde/saffron/src/main/saffron/runtime/EnumerationIterator.java#1 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
// 
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
*/

package saffron.runtime;
import java.util.Enumeration;
import java.util.Iterator;

/**
 * <code>EnumerationIterator</code> is an adapter which converts an {@link
 * Enumeration} into an {@link Iterator}.
 *
 * @author jhyde
 * @since 16 December, 2001
 * @version $Id: //guest/julian_hyde/saffron/src/main/saffron/runtime/EnumerationIterator.java#1 $
 **/
public class EnumerationIterator implements Iterator {
	Enumeration enumeration;
	public EnumerationIterator(Enumeration enumeration)
	{
		this.enumeration = enumeration;
	}
	public void remove() {
		throw new UnsupportedOperationException();
	}
	public Object next() {
		return enumeration.nextElement();
	}
	public boolean hasNext() {
		return enumeration.hasMoreElements();
	}
}


// End EnumerationIterator.java
