/*
// $Id: //guest/julian_hyde/saffron/src/main/saffron/runtime/IteratorPlan.java#1 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
// 
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
*/

package saffron.runtime;


/**
 * Base class for Plans which work by reading from an Iterator.
 **/
public abstract class IteratorPlan implements Plan {
	protected java.util.Iterator iterator;
	Object current;

	public final boolean hasNext()
	{
		return iterator.hasNext();
	}

	public final Object next()
	{
		return current = iterator.next();
	}

	public final Object current()
	{
		if (current == null) {
			throw saffron.util.Util.newInternal();
		}
		return current;
	}

	public void remove()
	{
		throw new java.lang.UnsupportedOperationException();
	}
}


// End IteratorPlan.java
