/*
// $Id: //guest/julian_hyde/saffron/src/main/saffron/test/TestContext.java#1 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
//
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
//
// jhyde, 18 April, 2002
*/
package saffron.test;

import saffron.Schema;
import saffron.Connection;
import saffron.Statement;

import java.io.PrintWriter;

/**
 * <code>TestContext</code> holds the stuff needed for saffron tests.
 *
 * @author jhyde
 * @since 18 April, 2002
 * @version $Id: //guest/julian_hyde/saffron/src/main/saffron/test/TestContext.java#1 $
 **/
class TestContext {
	static TestContext instance;

	static TestContext instance() {
		if (instance == null) {
			instance = new TestContext();
			instance.printWriter = new PrintWriter(System.out, true);
		}
		return instance;
	}

	PrintWriter getPrintWriter() {
		return printWriter;
	}

	PrintWriter printWriter;
}

// End TestContext.java
