/*
// $Id: //guest/julian_hyde/saffron/src/main/saffron/util/SaffronResource.java#1 $
// Saffron preprocessor and data engine
// Copyright (C) 2002 Julian Hyde <julian.hyde@mail.com>
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
// 
// See the COPYING file located in the top-level-directory of
// the archive of this library for complete text of license.
*/

package saffron.util;

/**
 * todo:
 **/
public class SaffronResource {
	static SaffronResource global = new SaffronResource();

	public static SaffronResource getDefault()
	{
		return global;
	}
	
	private RuntimeException newError()
	{
		return new RuntimeException();
	}

	private RuntimeException newError(String reason)
	{
		return new RuntimeException(reason);
	}

	public void assert(boolean b,String reason)
	{
		if (!b) {
			throw newError("saffron assertion failed: " + reason);
		}
	}

	public void assert(boolean b)
	{
		if (!b) {
			throw newError("saffron assertion failed");
		}
	}

  	public RuntimeException newInternal(Throwable e)
  	{
		return newError("received exception [" + e.toString() + "]");
	}

	public RuntimeException newInternal(Throwable e,String reason)
	{
		return newError(
			"received exception [" + e.toString() + "]; " + reason);
	}

	public RuntimeException newInternal()
	{
		return newError("internal error");
	}

	public RuntimeException newInternal(String reason)
	{
		return newError("internal error: " + reason);
	}
}


// End SaffronResource.java
